//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <map>
#include <string>
#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}


int main(int argc, char* argv[])
{

  //   ( "string/string") 
  typedef multimap<string,string> StrStrMMap;

  //    
  StrStrMMap dict;

  //      
  dict.insert(make_pair("day",""));
  dict.insert(make_pair("strange",""));
  dict.insert(make_pair("car",""));
  dict.insert(make_pair("smart",""));
  dict.insert(make_pair("trait",""));
  dict.insert(make_pair("strange",""));
  dict.insert(make_pair("smart",""));
  dict.insert(make_pair("smart",""));
  dict.insert(make_pair("clever",""));

  //   
  StrStrMMap::iterator pos;
  cout.setf (ios::left, ios::adjustfield);
  cout << ' ' << setw(10) << "english "
       << ToRus(" ") << endl; 
  cout << setfill('-') << setw(20) << " "
       << setfill(' ') << endl;
  for (pos = dict.begin(); pos != dict.end(); ++pos) { 
    cout << ' ' << setw(10) << pos->first.c_str() 
         << ToRus(pos->second) << endl;
  }
  cout << endl;

  //      "smart"
  string word ("smart");
  cout << word << ": " << endl;
  for (pos = dict.lower_bound(word);
       pos != dict.upper_bound(word); ++pos) {
    cout << "     " << ToRus(pos->second) << endl;
  }

  //      ""
  word = ("");
  cout << ToRus(word) << ": " << endl;
  for (pos = dict.begin(); pos != dict.end(); ++pos) {
    if (pos->second == word) {
      cout << "     " << pos->first << endl;

    }
  }

  getch();
  return 0;
}

//---------------------------------------------------------------------------
